<template>
  <div id="app">
  <div class="wrapper">
    <article class="passbox">
      <header>
        <div class="password">{{ generatedPassword }}</div>
      </header>
      <section>
        <div class="slidecontainer">
          <input type="range" min="8" max="24" v-model="passwordLength" class="slider" id="passRange">
          <label for="passRange" class="password__length">{{ passwordLength }}</label>
        </div>
        <div class="options">
          <label class="container" v-for="(option, index) in optiondata" :key="index">
            {{ option.name }}
            <input type="checkbox" v-model="option.status">
            <span class="checkmark"></span>
          </label>
        </div>
      </section>
      <footer>
        <button class="btn-refresh" @click="refreshPassword = !refreshPassword">Generate Password</button>
      </footer>
    </article>
  </div>
</div>
</template>

<script>
export default {
  name: 'App',
   data: () => ({
    passwordLength: 16,
    refreshPassword: false,
    optiondata: [
      {
        name: 'Lowercase',
        status: true,
        chars: 'abcdefghjkmnopqrstuvwxyz'
      },
      {
        name: 'Uppercase',
        status: true,
        chars: 'ABCDEFGHJKLMNOPQRSTUVWXYZ'
      },
      {
        name: 'Numbers',
        status: true,
        chars: '0123456789'
      },
      {
        name: 'Symbols',
        status: false,
        chars: '!$%&?+*#-/'
      }
    ]
  }),
  computed: {
    charset() {
      return [...this.optiondata]
        .map(element => {
        if(element.status === true)
          return element.chars;
      }).join('');
    },
    generatedPassword() {
      this.refreshPassword;

      return [...window.crypto.getRandomValues(new Uint32Array(this.passwordLength))]
        .map(value => this.charset[value % this.charset.length])
        .join('');
    }
  }
}
</script>

<style lang="scss">
body {
  background-color: rebeccapurple;
  margin: 0;
  padding: 0;
}

#app {
  font-family: 'Avenir', Helvetica, Arial;
  text-align: center;
  color: #fff;
  font-size: 2rem;
}

.wrapper {
  display: flex;
  justify-content: center;
  align-items: center;
  width: 100%;
  height: 100vh;
  overflow: hidden;
}

.passbox {
  width: 500px;
  border-radius: 5px;
  padding: 20px;
  background-color: rgb(46, 12, 80);
    box-shadow: 0 4px 10px rgb(0 0 0 / 50%);
  text-align: left;
  overflow: hidden;
}

header {
  .password {
    font-size: 1.8rem;
    overflow-wrap: break-word;
    padding: 16px;
    margin-bottom: 15px;
    background-color: rgb(69, 28, 109);
    border-width: 2px 0;
    text-align: left;
  }
}

section {
  .slidercontainer {
    width: 100%;
  }
  .slidecontainer {
    display: flex;
    align-items: center;
  }
  .password__length {
    background: #451c6d;
    padding: 10px 16px;
    margin-left: 20px;
    border-radius: 10px;
  }
  .slider {
    appearance: none;
    width: calc(100% - 20px);
    height: 8px;
    background-color: #95a5a6;
    outline: none;
    opacity: 0.7;
    transition:  opacity .2s;

    &:hover {
      opacity: 1;
    }

    &::-webkit-slider-thumb {
      appearance: none;
      width: 30px;
      height: 30px;
      border: 2px solid #ecb602;
      border-radius: 50%;
      background-color: #f1c40f;
      cursor: pointer;
    }
  }

  .options {
    display: flex;
    justify-content: space-around;
    align-items: center;
    flex-wrap: wrap;
    padding: 20px;

    .container {
      display: block;
      position: relative;
      width: 160px;
      padding-left: 35px;
      margin-bottom: 12px;
      font-size: 1.4rem;
      user-select: none;
      cursor: pointer;

      &:hover input ~ .checkmark {
        background-color: #f1c40f;
      }
    }

    .container input {
      position: absolute;
      cursor: pointer;
      opacity: 0;
      height: 0;
      width: 0;

      &:checked ~ .checkmark {
        background-color: #ecb602;

        &:after {
          display: block;
        }
      }
    }

    .checkmark {
      position: absolute;
      top: 0;
      left: 0;
      height: 25px;
      width:25px;
      background-color: #95a5a6;

      &:after {
        content: "";
        position: absolute;
        display: none;
        left: 9px;
        top:5px;
        width: 5px;
        height: 10px;
        border: solid #fff;
        border-width: 0 3px 3px 0;
        transform: rotate(45deg);
      }
    }
  }
}

footer {
  .btn-refresh {
    font-size: 1.6rem;
    border: none;
    border-radius: 5px;
    background-color: #ecb602;
    margin-top: 10px;
    color: rebeccapurple;
    padding: 16px 10px;
    width: 100%;
    outline:none;
    cursor: pointer;
    font-weight: 600;
  }
}

#yt_link
{
  position: absolute;
  right: 0;
  left: 0;
  bottom: -200px;
  display: block;
  width: 160px;
  text-align: center;
  color: red;
  font-size: 15px;
  text-decoration: none;
  font-family: Verdana, Geneva, Tahoma, sans-serif;
  padding: 10px;
  margin: 0 auto;
  background-color: #fff;
  border-radius: 2px;
  animation: showYtLink 1.5s ease 3s forwards;
}

@keyframes showYtLink
{
  0%{ bottom: -200px; }
  100%{ bottom: 20px; }
}
</style>
